static const char *RcsId = "$Header: /cvsroot/tango-ds/Instrumentation/Diffractometer/src/pseudoaxis/PseudoAxisStateMachine.cpp,v 1.3 2008/09/24 08:37:48 piccaf Exp $";
//+=============================================================================
//
// file :         PseudoAxisStateMachine.cpp
//
// description :  C++ source for the PseudoAxis and its alowed. 
//                method for commands and attributes
//
// project :      TANGO Device Server
//
// $Author: piccaf $
//
// $Revision: 1.3 $
//
// $Log: PseudoAxisStateMachine.cpp,v $
// Revision 1.3  2008/09/24 08:37:48  piccaf
// * add dummy commandes for the Axis V2 interface
//
// Revision 1.2  2008/09/22 08:46:40  piccaf
// * add files from the new diffractometer Device
//
// Revision 1.4  2007/07/25 09:58:22  picca
// Can not write on an OFF PseudoAxe, and no more delta moving when writing on pseudoAxes
//
// * modification of the PseudoAxe state machine to forbid writting on an OFF PseudoAxe. close #6247
// * Now when we change from simulated to real state, update the libHKL from the hardware. so no more unsynchronyse state between the device and the HKL. close #4013 #6168 #6196
//
// Revision 1.3  2007/07/11 07:19:28  picca
// * add the "offset" and the "relativeMove" attributes  to the PseudoAxes.
// * syntax in Kappa6C
//
// Revision 1.2  2007/05/15 08:26:58  hardion
// * Merge with branch DIFFRACTO_KAPPA_6C
//
// Revision 1.1.2.1  2006/08/25 15:08:22  hardion
// * Merge corrections of hubert
// * Create directory for each class of device
// * Fix problem when PseudoAxis is initialized on first
// * Tested on diffabs for the communication part
//
// Revision 1.3  2006/07/07 15:14:58  hardion
// * Fix bug 1974 ( initialize properties before initialize hklAdapter !!!)
// * Change State Machine (no more OFF state)
// * State ALARM == axis not initialized
// * Implements stop command
//
// Revision 1.2  2006/07/06 10:29:44  hardion
// * commit to keep modification about Pseudo axis management but it doesn't work ( Error Check the wavelength)
// try to come back to old version to see if the problem persists
//
// Revision 1.1  2006/03/29 16:45:47  hardion
// * Add PseudoAxis device
// * Add DiffractometerFactory which associates Diffracto and PseudoAxis
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#include <tango.h>
#include <PseudoAxis.h>
#include <PseudoAxisClass.h>

/*====================================================================
 *	This file contains the methods to allow commands and attributes
 * read or write execution.
 *
 * If you wand to add your own code, add it between 
 * the "End/Re-Start of Generated Code" comments.
 *
 * If you want, you can also add your own methods.
 *====================================================================
 */

namespace PseudoAxis_ns
{

//=================================================
//		Attributes Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_IsInitialised_allowed
// 
// description : 	Read/Write allowed for IsInitialised attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_IsInitialised_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_offset_allowed
// 
// description : 	Read/Write allowed for offset attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_offset_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::MOVING)
	{
		//	End of Generated Code
		if(type == Tango::READ_REQ)
			return true;
		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_relativeMove_allowed
// 
// description : 	Read/Write allowed for relativeMove attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_relativeMove_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF)
	{
		//	End of Generated Code
		if(type == Tango::READ_REQ)
			return true;
		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_position_allowed
// 
// description : 	Read/Write allowed for position attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_position_allowed(Tango::AttReqType type)
{
	if (get_state() == Tango::OFF)
	{
		//	End of Generated Code
		if(type == Tango::READ_REQ)
			return true;
		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_mode_allowed
// 
// description : 	Read/Write allowed for mode attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_mode_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_modeNames_allowed
// 
// description : 	Read/Write allowed for modeNames attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_modeNames_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_initialized_allowed
// 
// description : 	Read/Write allowed for initialized attribute.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_initialized_allowed(Tango::AttReqType type)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_MotorOFF_allowed
// 
// description : 	Execution allowed for MotorOFF command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_MotorOFF_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::MOVING)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_MotorON_allowed
// 
// description : 	Execution allowed for MotorON command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_MotorON_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::MOVING)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_ComputeNewOffset_allowed
// 
// description : 	Execution allowed for ComputeNewOffset command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_ComputeNewOffset_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::MOVING)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_Stop_allowed
// 
// description : 	Execution allowed for Stop command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_Stop_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::OFF	||
		get_state() == Tango::DISABLE)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_MotorInit_allowed
// 
// description : 	Execution allowed for MotorInit command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_MotorInit_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::MOVING)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_Backward_allowed
// 
// description : 	Execution allowed for Backward command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_Backward_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_Forward_allowed
// 
// description : 	Execution allowed for Forward command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_Forward_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_DefinePosition_allowed
// 
// description : 	Execution allowed for DefinePosition command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_DefinePosition_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_InitializeReferencePosition_allowed
// 
// description : 	Execution allowed for InitializeReferencePosition command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_InitializeReferencePosition_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_GetModeParameters_allowed
// 
// description : 	Execution allowed for GetModeParameters command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_GetModeParameters_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_SetModeParameters_allowed
// 
// description : 	Execution allowed for SetModeParameters command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_SetModeParameters_allowed(const CORBA::Any &any)
{
		//	End of Generated Code

		//	Re-Start of Generated Code
	return true;
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxis::is_On_allowed
// 
// description : 	Execution allowed for On command.
//
//-----------------------------------------------------------------------------
bool PseudoAxis::is_On_allowed(const CORBA::Any &any)
{
	if (get_state() == Tango::MOVING)
	{
		//	End of Generated Code

		//	Re-Start of Generated Code
		return false;
	}
	return true;
}

}	// namespace PseudoAxis_ns
